/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __ALGORITHM_FUNCTION_H
#define __ALGORITHM_FUNCTION_H

namespace magnum { namespace algorithm {

template<class C, class F> inline void for_each(C& container, F& function);
template<class I, class F> inline void for_each(const I& begin, const I& end, F& function);
template<class C, class G> inline void generate(C& container, G& generator);
template<class I, class G> inline void generate(const I& begin, const I& end, G& generator);
template<class C, class T> inline void count(const C& container, const T& item);
template<class I, class T> inline unsigned int count(const I& begin, const I& end, const T& item);
template<class I, class J> inline J copy(const I& begin, const I& end, const J& result);

}; };

#endif

