/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __ALGORITHM_SUBSET_H
#define __ALGORITHM_SUBSET_H

#include "container.array.h"

namespace magnum { namespace algorithm {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Array;

class Collection;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Subset : public Object {
DeclareClass(Subset, Object);
friend Collection;
private:
	unsigned int			m_Size;
	unsigned int*			m_Subset;
	
private:
	inline Subset();

public:
	inline unsigned int		getSize() const;
	inline unsigned int		operator[](unsigned int ) const;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Collection : public Object {
DeclareClass(Collection, Object);
private:
	unsigned int*		m_Set;
	Array<Subset>		m_Collection;

public:
	typedef magnum::container::Array<Subset>::Iterator	Iterator;

public:
	Collection();
	~Collection();

	inline bool			isEmpty() const;
	inline unsigned int	getSize() const;

	inline Iterator		begin() const;
	inline Iterator		end() const;

	inline const Subset& operator[](unsigned int ) const;
	inline Subset&		operator[](unsigned int );

	void				kSubsets(unsigned int setsize, unsigned int k);
	void				bipartitions(unsigned int setsize, unsigned int k);
};

}; };

#endif
