/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __APPLICATION_MESSAGEQUEUE_INL
#define __APPLICATION_MESSAGEQUEUE_INL

namespace magnum { namespace application {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool MessageQueue::insert(Message* msg) {
	m_Queue.insert(msg);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool MessageQueue::insertHead(Message* msg) {
	m_Queue.insertHead(msg);
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void MessageQueue::clear() {
	m_Queue.clear();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message* MessageQueue::removeHead() {
	return m_Queue.removeHead();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message* MessageQueue::peekHead() const {
	return m_Queue.peekHead();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message* MessageQueue::removeTail() {
	return m_Queue.removeTail();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Message* MessageQueue::peekTail() const {
	return m_Queue.peekTail();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool MessageQueue::isEmpty() const {
	return m_Queue.isEmpty();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int MessageQueue::getSize() const {
	return m_Queue.getSize();
}

}; };

#endif
