/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __AUDIO3D_BUFFER_H
#define __AUDIO3D_BUFFER_H

#include "audio3d.device.h"
#include "container.array.h"

namespace magnum { namespace audio3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Array;

class Source;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Buffer : public Object {
DeclareClass(Buffer, Object);
friend class Source;
public:
	enum Format {
		Mono8 = AL_FORMAT_MONO8,
		Mono16 = AL_FORMAT_MONO16,
		Stereo8 = AL_FORMAT_STEREO8,
		Stereo16 = AL_FORMAT_STEREO16,
	};

private:
	unsigned int			m_Buffer;
	Format					m_Format;
	unsigned int			m_Frequency;
							
protected:					
	inline Buffer();		
							
public:						
	~Buffer();				
							
	static Buffer*			create(Format ,unsigned int );
							
	inline void				setBuffer(const void* ,unsigned int );
							
	inline unsigned int		getFrequency() const;
	inline Format			getFormat() const;
	inline unsigned int		getSize() const;
};

typedef Array<Buffer*>		BufferList;

}; };

#endif
