/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __AUDIO3D_LISTENER_H
#define __AUDIO3D_LISTENER_H

#include "object.h"
#include "math.vector3.h"

namespace magnum { namespace audio3d {
using magnum::object::Object;
using magnum::math::Vector3;
using magnum::object::Object;
using magnum::types::String;

class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Listener : public Object {
DeclareClass(Listener, Object);
private:
	Context*				m_Context;
	Vector3<float>			m_Position;
	Vector3<float>			m_Velocity;
	Vector3<float>			m_Orientation;

public:	
	Listener();
	~Listener();

	inline void				select();

	inline void				setPosition(const Vector3<float>& );
	inline void				setPosition(float ,float ,float );
	inline const Vector3<float>& getPosition() const;

	inline void				setVelocity(const Vector3<float>& );
	inline void				setVelocity(float ,float ,float );
	inline const Vector3<float>& getVelocity() const;

	inline void				setOrientation(const Vector3<float>& );
	inline void				setOrientation(float ,float ,float );
	inline const Vector3<float>& getOrientation() const;

};

}; };

#endif
