/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __BASE_NUMBER_INL
#define __BASE_NUMBER_INL

namespace magnum { namespace types {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Byte::Byte() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Byte::Byte(unsigned char v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Byte::Byte(const Byte& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator==(const Byte& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator!=(const Byte& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator>(const Byte& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator<(const Byte& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator>=(const Byte& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Byte::operator<=(const Byte& v) const {
	return m_Value <= v.m_Value;
}




/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Short::Short() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Short::Short(short v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Short::Short(const Short& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator==(const Short& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator!=(const Short& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator>(const Short& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator<(const Short& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator>=(const Short& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Short::operator<=(const Short& v) const {
	return m_Value <= v.m_Value;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Long::Long() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Long::Long(long v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Long::Long(const Long& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator==(const Long& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator!=(const Long& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator>(const Long& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator<(const Long& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator>=(const Long& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Long::operator<=(const Long& v) const {
	return m_Value <= v.m_Value;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Integer::Integer() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Integer::Integer(int v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Integer::Integer(const Integer& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator==(const Integer& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator!=(const Integer& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator>(const Integer& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator<(const Integer& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator>=(const Integer& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Integer::operator<=(const Integer& v) const {
	return m_Value <= v.m_Value;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Double::Double() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Double::Double(double v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Double::Double(const Double& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator==(const Double& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator!=(const Double& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator>(const Double& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator<(const Double& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator>=(const Double& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Double::operator<=(const Double& v) const {
	return m_Value <= v.m_Value;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Float::Float() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Float::Float(float v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Float::Float(const Float& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator==(const Float& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator!=(const Float& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator>(const Float& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator<(const Float& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator>=(const Float& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Float::operator<=(const Float& v) const {
	return m_Value <= v.m_Value;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Bool::Bool() {
	m_Value = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Bool::Bool(bool v) {
	m_Value = v;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Bool::Bool(const Bool& v) {
	m_Value = v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator==(const Bool& v) const {
	return m_Value == v.m_Value;
}

 
/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator!=(const Bool& v) const {
	return m_Value != v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator>(const Bool& v) const {
	return m_Value > v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator<(const Bool& v) const {
	return m_Value < v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator>=(const Bool& v) const {
	return m_Value >= v.m_Value;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Bool::operator<=(const Bool& v) const {
	return m_Value <= v.m_Value;
}

}; };
#endif
