/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __CONTAINER_COMPOUND_H
#define __CONTAINER_COMPOUND_H

namespace magnum { namespace container {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class K, class T> class Compound {
private:
	K		m_Key;
	T		m_Item;

public:
	inline Compound();
	inline Compound(const K&, const T& );

	inline T&			operator*();
	inline const T&		operator*() const;
	inline T*			operator->();
	inline const T*		operator->() const;

	inline const K&		getKey() const;
	inline void			setKey(const K& );
	inline const T&		getItem() const;
	inline void			setItem(const T& );

	inline bool operator==(const Compound& ) const;
	inline bool operator!=(const Compound& ) const;
	inline bool operator<=(const Compound& ) const;
	inline bool operator<(const Compound& ) const;
	inline bool operator>=(const Compound& ) const;
	inline bool operator>(const Compound& ) const;

	inline bool operator==(const K& ) const;
	inline bool operator!=(const K& ) const;
	inline bool operator<=(const K& ) const;
	inline bool operator<(const K& ) const;
	inline bool operator>=(const K& ) const;
	inline bool operator>(const K& ) const;
};

}; };

#endif
