/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __FREETYPE_DESCRIPTOR_H
#define __FREETYPE_DESCRIPTOR_H

#include "graphics.dimension.h"
#include "freetype.encoding.h"

namespace magnum { namespace freetype {
using magnum::graphics::Dimension;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Descriptor : public Object {
DeclareClass(Descriptor, Object);
private:
	String					m_Family;
	String					m_Style;
	Dimension<float>		m_Size;
	Encoding::Type			m_Encoding;
	bool					m_Kerning;

public:
	Descriptor();
	
	inline String			getName() const;
	
	inline void				setFamily(const char* );
	inline const String&	getFamily() const;
	
	inline void				setStyle(const char* );
	inline const String&	getStyle() const;

	inline void				setSize(float );
	inline void				setSize(float ,float );
	inline void				setSize(const Dimension<float>& );
	inline const Dimension<float>& getSize() const;
	inline float			getWidth() const;
	inline float			getHeight() const;

	inline void				setEncoding(Encoding::Type );
	inline Encoding::Type	getEncoding() const;

	inline void				setKerning(bool );
	inline bool				getKerning() const;

	bool					operator==(const Descriptor& ) const;
	bool					operator!=(const Descriptor& ) const;
};

}; };

#endif
