/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GEOMETRY_CONE_H
#define __GEOMETRY_CONE_H

#include "geometry.body.h"

namespace magnum { namespace geometry {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Cone3 : public Body<T,3> {
private:
	Vector3<T>			m_Origin;
	Vector3<T>			m_Direction;
	T					m_Length;
	T					m_Radius;
	
public:
	inline void			setOrigin(const Vector3<T>& );
	inline const Vector3<T>& getOrigin() const;
	
	inline void			setDirection(const Vector3<T>& );
	inline const Vector3<T>& getDirection() const;

	inline void			setLength(const T& );
	inline T			getLength() const;

	inline bool			isEmpty() const;

	inline bool			isInside(const Vector3<T>& ) const;
	inline T			getDistance2(const Vector3<T>& ) const;
};

}; };

#endif
