/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GEOMETRY_TRIANGLE_INL
#define __GEOMETRY_TRIANGLE_INL


namespace magnum { namespace geometry {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, int dim> inline Triangle<T,dim>::Triangle() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, int dim> inline Triangle<T,dim>::Triangle(const Vector<T,dim>& v1, const Vector<T,dim>& v2, const Vector<T,dim>& v3) {
	a = v1;
	b = v2;
	c = v3;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, int dim> inline Vector<T,dim>& Triangle<T,dim>::operator [](unsigned int i) {
	return *(&a + i);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T, int dim> inline Vector<T,dim> Triangle<T,dim>::operator [](unsigned int i) const {
	return *(&a + i);
}


}; };

#endif
