/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS_FILTER_DEPTH_H
#define __GRAPHICS_FILTER_DEPTH_H

#include "graphics.filter.h"

namespace magnum {namespace graphics {
using magnum::io::Filter;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FilterDepth : public FilterImage {
DeclareClass(FilterDepth, FilterImage);
private:
	Image::Type	m_Type;

public:
	inline FilterDepth(Image::Type t=Image::Unknown);

	inline Image::Type	getType() const;
	inline void			setType(Image::Type t);

protected:
	Image*		process(const Image* );

private:
	Image*		convertRGB2PAL(Image* );
	Image*		convertPAL2RGB(Image* );
	Image*		convertRGB2RGB(Image* );
};


}; };

#endif
