/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_AMBIENTLIGHT_H
#define __GRAPHICS3D_AMBIENTLIGHT_H

#include "object.h"
#include "graphics.colour.h"
#include "graphics3d.light.h"


namespace magnum { namespace graphics3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::graphics::Colour;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class AmbientLight : public Light {
DeclareClass(AmbientLight, Light);
private:
	Colour<float>				m_Ambient;

public:
	inline AmbientLight();

public:
	inline const Colour<float>& getAmbient() const;
	inline void 				setAmbient(const Colour<float>& );

protected:
	virtual void				onSelect(unsigned int i) const;
};

}; };

#endif
