/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_APPEARANCE_INL
#define __GRAPHICS3D_APPEARANCE_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Material* Appearance::getMaterial() const {
	return m_Material;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::attachMaterial(Material* mat) {
	ASSERT(mat != NULL);
	m_Material = mat;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::detachMaterial() {
	m_Material = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Shader* Appearance::getShader() const {
	return m_Shader;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::attachShader(Shader* s) {
	ASSERT(s != NULL);

	m_Shader = s;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::detachShader() {
	m_Shader = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::attachTexture(Texture* t, unsigned int stage) {
	ASSERT((stage >= 0) && (stage < Texture::MaxTextures));
	ASSERT(t != NULL);
	m_Texture[stage] = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Appearance::detachTexture(unsigned int stage) {
	ASSERT((stage >= 0) && (stage < Texture::MaxTextures));
	m_Texture[stage] = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Texture*	Appearance::getTexture(unsigned int stage) const {
	ASSERT((stage >= 0) && (stage < Texture::MaxTextures));
	return m_Texture[stage];
}


}; };

#endif
