/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_CAMERA_H
#define __GRAPHICS3D_CAMERA_H

#include "math.vector3.h"
#include "math.matrix.h"
#include "graphics.rectangle.h"
#include "graphics3d.resource.h"


namespace magnum { namespace graphics3d {
using magnum::math::Vector3;
using magnum::math::Matrix3;
using magnum::math::Matrix4;
using magnum::graphics::Rectangle;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Camera : public Resource {
DeclareClass(Camera, Resource);
private:
	float				m_NearPlane;
	float				m_FarPlane;
	float				m_ViewPlane;
	Rectangle<float>	m_ViewWindow;
	Matrix4<float>		m_Matrix;

public:
	inline Camera();

	inline void			select() const;

	inline void			setViewPlane(float );
	inline float		getViewPlane() const;
	inline void			setViewWindow(const Rectangle<float>& );
	inline void			setNearPlane(float );
	inline float		getNearPlane() const;
	inline void			setFarPlane(float );
	inline float		getFarPlane() const;

	inline void			setTransform(const Matrix4<float>& );
	inline void			setTransform(const Matrix3<float>& );
	inline void			setPosition(const Vector3<float>& );

protected:
	virtual void		onSelect() const;
};

}; };

#endif
