/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_MATERIAL_INL
#define __GRAPHICS3D_MATERIAL_INL

namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Material::Material() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Material::select() const {
	MaterialStack* ms = getContext()->getMaterialStack();
	const Material* cur = ms->m_Material;
	if (cur == this)
		return;
	ms->m_Material = this;
	onSelect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Material::forceSelect() const {
	MaterialStack* ms = getContext()->getMaterialStack();
	ms->m_Material = this;
	onSelect();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Material::deselect() const {
	MaterialStack* ms = getContext()->getMaterialStack();
	if (ms->m_Material == this)
		ms->m_Material = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Material::selectNone() {
	Context* context = getContext();
	MaterialStack* ms = context->getMaterialStack();
	ms->m_Material = NULL;
}


}; };

#endif

