/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_MESHCONVERTER_H
#define __GRAPHICS3D_MESHCONVERTER_H

#include "io.filter.h"
#include "graphics3d.mesh.h"

namespace magnum {namespace graphics3d {
using magnum::io::Filter;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class MeshConverter : public Filter<Mesh> {
DeclareClass(MeshConverter, Filter<Mesh>);
private:
	Mesh::Primitive		m_Primitive;

public:
	MeshConverter();

	inline void			setPrimitive(Mesh::Primitive );
	inline Mesh::Primitive getPrimitive() const;

protected:
	Mesh*				process(const Mesh* );

private:
	// TL = TriangleList
	// TS = TriangleStrip
	// QL = QuadList
	// QS = QuadStrip
	Mesh*				convertTL2TS(const Mesh* );
	Mesh*				convertTS2TL(const Mesh* );
	Mesh*				convertQL2TS(const Mesh* );
	Mesh*				convertQL2TL(const Mesh* );
	Mesh*				convertQS2TS(const Mesh* );
	Mesh*				convertQS2TL(const Mesh* );
};

}; };

#endif


