#ifndef __GRAPHICS3D_PARAMETERFORMAT_INL
#define __GRAPHICS3D_PARAMETERFORMAT_INL


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ParameterFormat::ParameterFormat() {
	m_Length = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void ParameterFormat::clear() {
	m_Components.clear();
	m_Length = 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ParameterFormat::getSize() const {
	return m_Components.getSize();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ParameterFormat::getLength() const {
	return m_Length;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Types::Type ParameterFormat::getType(const char* name) const {
	return at(name)->m_Type;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ParameterBuffer::Location ParameterFormat::getLocation(const char* name) const {
	return at(name)->m_Location;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int ParameterFormat::getSize(const char* name) const {
	return ((at(name)->m_Type >> Types::SizeShift) & Types::SizeMask);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* ParameterFormat::getDescription(const char* name) const {
	return at(name)->m_Description;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const ParameterFormat& ParameterFormat::operator=(const ParameterFormat& fmt) {
	m_Components = fmt.m_Components;
	m_Length = fmt.m_Length;
	return *this;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ParameterFormat::Iterator ParameterFormat::begin() const {
	return m_Components.begin();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ParameterFormat::Iterator ParameterFormat::end() const {
	return m_Components.end();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* ParameterFormat::Component::getName() const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const char* ParameterFormat::Component::getDescription() const {
	return m_Description;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Types::Type ParameterFormat::Component::getType() const {
	return m_Type;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ParameterBuffer::Location ParameterFormat::Component::getLocation() const {
	return m_Location;
}

}; };

#endif
