/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_SHADERSTACK_H
#define __GRAPHICS3D_SHADERSTACK_H

namespace magnum {namespace graphics3d {
class Shader;
class PixelProgram;
class VertexProgram;
class Context;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ShaderStack : public Object {
DeclareClass(ShaderStack, Object);
friend Shader;
friend PixelProgram;
friend VertexProgram;
friend Context;
private:
	const Shader*		m_Shader;
	const PixelProgram*	m_PixelProgram;
	const VertexProgram* m_VertexProgram;
	unsigned int		m_Attributes;

private:
	inline ShaderStack();

public:
	inline const Shader*		getShader() const;
	inline const PixelProgram*	getPixelProgram() const;
	inline const VertexProgram*	getVeretxProgram() const;
};

}; };

#endif
