/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_STATICMODEL_H
#define __GRAPHICS3D_STATICMODEL_H

#include "graphics3d.model.h"
#include "graphics3d.mesh.h"
#include "graphics3d.renderstream.h"
#include "object.pointer.h"


namespace magnum { namespace graphics3d {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class StaticModel : public Model {
DeclareClass(StaticModel, Model);
private:
	typedef Pointer<Mesh>	MeshP;
	Array<MeshP>			m_Meshes;
	Pointer<RenderStream>	m_Stream;

public:
	void					clear();
	void					finish();

	void					insertMesh(Mesh* );
	void					removeMesh(Mesh* );

	void					getMeshes(Array<Mesh*>* ) const;

protected:
	virtual void			onRender(const ParameterBuffer* ) const;
	virtual bool			onOptimize();
};

}; };

#endif
