/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_TEXTURE1D_H
#define __GRAPHICS3D_TEXTURE1D_H

#include "graphics.image.h"
#include "graphics3d.texture.h"

namespace magnum { namespace graphics3d {
using magnum::graphics::Image;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Texture1D : public Texture {
DeclareClass(Texture1D, Texture);
private:
	unsigned int	m_Size;
	unsigned int	m_Levels;
	bool			m_Locked;
	
protected:
	Texture1D(unsigned int tex);

public:
	inline static unsigned int	getMinSize();
	inline static unsigned int	getMaxSize();

	static Texture1D*	create(Type ,unsigned int size, int levels = GenerateAll);
	static Texture1D*	create(const Image* , int levels = GenerateAll);

	~Texture1D();

	void*				lock(int, unsigned int, LockFlag );
	void				unlock();
	inline bool			isLocked() const;

	inline unsigned int	getSize() const;
	inline unsigned int	getLevels() const;
};

}; };

#endif
