/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_TEXTURESTACK_H
#define __GRAPHICS3D_TEXTURESTACK_H

#include "object.h"
#include "graphics.dimension.h"
#include "graphics3d.texture.h"


namespace magnum {namespace graphics3d {
using magnum::graphics::Dimension;

class Context;
class Texture1D;
class Texture2D;
class Texture3D;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class TextureStack : public Object {
DeclareClass(TextureStack, Object);
friend Texture;
friend Texture1D;
friend Texture2D;
friend Texture3D;
friend Context;
private:
	const Texture*		m_Texture[Texture::MaxTextures];
	unsigned int		m_OglTarget[Texture::MaxTextures];
	unsigned int		m_MaxTexture1DSize;
	unsigned int		m_MinTexture1DSize;
	Dimension<int>		m_MaxTexture2DSize;
	Dimension<int>		m_MinTexture2DSize;
	int					m_MaxTextures;

private:
	TextureStack();

public:
	inline const Texture* getTexture(unsigned int = 0) const;
	inline unsigned int	getTarget(unsigned int = 0) const;

	inline int			getMaxTextures() const;
};

}; };

#endif
