/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GRAPHICS3D_VERTEXMESH_INL
#define __GRAPHICS3D_VERTEXMESH_INL

namespace magnum { namespace graphics3d {



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline VertexBuffer* VertexMesh::getVertexBuffer(unsigned int i) const {
	ASSERT(i < VertexBuffer::MaxBuffers);
	return m_VertexBuffer[i];
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Range<unsigned int> VertexMesh::getRange() const {
	return m_Range;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void VertexMesh::setRange(unsigned int start, unsigned int size) {
	m_Range.setStart(start);
	m_Range.setEnd(start + size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void VertexMesh::setRange(const Range<unsigned int>& r) {
	m_Range = r;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void VertexMesh::selectVertexBuffers() const {
	for (unsigned int i = 0; i < m_BufferCount; i++) {
		if (m_VertexBuffer[i] != NULL) {
			m_VertexBuffer[i]->select();
		}
	}
}



}; };

#endif
