/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI_IMAGEVIEW_INL
#define __GUI_IMAGEVIEW_INL

namespace magnum { namespace gui {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ImageView::ImageView(const Rectangle<float>& frame, Bitmap* img) : View(frame) {
	m_Image = img;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline ImageView::~ImageView() {
	m_Image = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Bitmap* ImageView::getImage() const {
	return m_Image;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	ImageView::setImage(Bitmap* img) {
	m_Image = img;
}

}; };

#endif
