/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI_SCREEN_H
#define __GUI_SCREEN_H

#include "graphics.image.h"
#include "graphics.rectangle.h"

namespace magnum { namespace gui {
using magnum::object::Object;
using magnum::types::String;
using magnum::graphics::Image;
using magnum::graphics::Rectangle;
using magnum::graphics::Palette;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Screen : public Object {
DeclareClass(Screen, Object);
public:
	typedef magnum::graphics::Image::Type	Type;

private:
	Type				m_Type;
	Rectangle<float>	m_Frame;

public:
	Screen();

	bool				getPalette(Palette<byte>& pal) const;
	bool				setPalette(const Palette<byte>& pal);

	Rectangle<float>&	getFrame() const;
	Type				getType() const;
};

}; };

#endif
