/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __GUI3D_FONTCACHE_H
#define __GUI3D_FONTCACHE_H

#include "container.map.h"
#include "freetype.font.h"

namespace magnum { namespace gui3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Map;
using magnum::freetype::Font;

class FontMap;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class FontCache : public Object {
DeclareClass(FontCache, Object);
public:
	typedef Map<const Font*, FontMap*>::Iterator	Iterator;

private:
	Map<const Font*, FontMap*>		m_Fonts;
	
public:
	~FontCache();
	
	inline bool			contains(const Font* ) const;
	void				insert(const Font* ,FontMap* );
	void				remove(const Font* );
	void				remove(const Iterator& item);
	void				clear();

	FontMap*			get(const Font* );

	inline unsigned int getSize() const;
	inline bool			isEmpty() const;

	inline Iterator		begin() const;
	inline Iterator 	at(const Font* ) const;
	inline Iterator		end() const;
};

}; };

#endif
