#ifndef __IO_FILE_INL
#define __IO_FILE_INL

namespace magnum { namespace io {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline File::File() {
	m_InputStream.m_File = this;
	m_OutputStream.m_File = this;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline File::~File() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputStream* File::getInputStream() {
	return &m_InputStream;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputStream* File::getOutputStream() {
	return &m_OutputStream;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long File::FileInputStream::read(void *buffer, unsigned long size) {
	return m_File->read(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long File::FileInputStream::skip(unsigned long size) {
	unsigned long pos = m_File->getPosition();
	m_File->setPosition(size, File::Current);
	return m_File->getPosition() - pos;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long File::FileInputStream::available() {
	return m_File->getSize() - m_File->getPosition();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool File::FileInputStream::close() {
	release();
	return true;
}



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned long File::FileOutputStream::write(const void *buffer, unsigned long size) {
	return m_File->write(buffer, size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	File::FileOutputStream::flush() {
	return m_File->flush();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool File::FileOutputStream::close() {
	release();
	return true;
}

};
};

#endif
