/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_FILTER_H
#define __IO_FILTER_H

#include "object.h"
#include "container.chain.h"

namespace magnum {namespace io {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Chain;
using magnum::container::Chainable;

template<class T> class FilterChain;
template<class T> class Filter;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class Filter : public Object, private Chainable<Filter> {
DeclareClass(Filter, Object);
public:
	inline FilterChain<T> operator<<(Filter& );
	inline T*			operator<<(const T* );

protected:
	virtual T*			process(const T* ) = 0;
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
template<class T> class FilterChain : public Filter<T> {
DeclareClass(FilterChain, Filter);
private:
	typedef Filter<T>	Filter_t;
	Chain<Filter_t>		m_Filters;

public:
	inline FilterChain();
	inline FilterChain(Filter& );
	inline FilterChain(Filter& , Filter& );

	inline FilterChain&	operator<<(Filter& );
	inline const FilterChain& operator=(FilterChain& );

	inline void			append(Filter& );

protected:
	T					process(const T& );
};


}; };


#endif
