/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __IO_OUTPUTSTREAM_H
#define __IO_OUTPUTSTREAM_H

#include "io.stream.h"
#include "base.string.h"


namespace magnum { namespace io {
using magnum::object::Object;
using magnum::types::String;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class OutputStream : public Stream {
DeclareClass(OutputStream, Stream);
private:
	int			m_FloatDigits;

public:
	inline OutputStream();

	virtual unsigned long write(const void *buffer, unsigned long size) = 0;
	virtual bool	flush() = 0;
	virtual bool	close() = 0;

	inline OutputStream& operator<<(const char* str);
	inline OutputStream& operator<<(signed char val);
	inline OutputStream& operator<<(unsigned char val);
	inline OutputStream& operator<<(signed short val);
	inline OutputStream& operator<<(unsigned short val);
	inline OutputStream& operator<<(signed int val);
	inline OutputStream& operator<<(unsigned int val);
	inline OutputStream& operator<<(signed long val);
	inline OutputStream& operator<<(unsigned long val);
	inline OutputStream& operator<<(float val);
	inline OutputStream& operator<<(double val);
};

inline OutputStream& operator<<(OutputStream&, const String& str);
inline OutputStream* operator<<(OutputStream*, const String& str);
inline OutputStream& operator<<(OutputStream&, const Object& str);
inline OutputStream* operator<<(OutputStream*, const Object& str);

}; };
#endif
