/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/


#ifndef __MAGNUM_MEDIA_H
#define __MAGNUM_MEDIA_H

// Multimedia Stuff
#include "media.node.h"
#include "media.pin.h"
#include "media.graph.h"
#include "media.format.h"
#include "media.buffer.h"
#include "media.device.h"
#include "media.filter.h"
#include "media.handler.h"
#include "media.processor.h"
#include "media.midi.h"
#include "media.audio.h"
#include "media.audioRenderer.h"
#include "media.video.h"

#include "media.node.inl"
#include "media.pin.inl"
#include "media.graph.inl"
#include "media.format.inl"
#include "media.buffer.inl"
#include "media.device.inl"
#include "media.filter.inl"
#include "media.handler.inl"
#include "media.processor.inl"
#include "media.midi.inl"
#include "media.audio.inl"
#include "media.audioRenderer.inl"
#include "media.video.inl"


# if defined(__FORWINDOWS__)
#	include "media.waveproducer.win.h"
#	include "media.waveconsumer.win.h"
#	include "media.wavedevice.win.h"
#
#	include "media.waveproducer.win.inl"
#	include "media.waveconsumer.win.inl"
#	include "media.wavedevice.win.inl"
# endif


#include "media.sound.h"

#include "media.sound.inl"


#endif
