/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MATH_CONSTS_H
#define __MATH_CONSTS_H

#include "base.types.h"
#include <math.h>

namespace magnum { namespace math {

/* Constants rounded for 21 decimals. */
#ifndef M_E
#define M_E         (2.71828182845904523536)
#define M_LOG2E     (1.44269504088896340736)
#define M_LOG10E    (0.434294481903251827651)
#define M_LN2       (0.693147180559945309417)
#define M_LN10      (2.30258509299404568402)
#define M_PI        (3.14159265358979323846)
#define M_PI_2      (1.57079632679489661923)
#define M_PI_4      (0.785398163397448309616)
#define M_1_PI      (0.318309886183790671538)
#define M_2_PI      (0.636619772367581343076)
#define M_1_SQRTPI  (0.564189583547756286948)
#define M_2_SQRTPI  (1.12837916709551257390)
#define M_SQRT2     (1.41421356237309504880)
#define M_SQRT_2    (0.707106781186547524401)
#endif



#ifdef max
#undef max
#undef min
#endif

template<class T> inline T max(T a,T b)	{return (a > b) ? a : b; };
template<class T> inline T min(T a,T b)	{return (a < b) ? a : b; };
template<class T> inline T abs(T a) {return (a < T(0)) ? -a : a; };
template<> inline float abs(float a) {return fabsf(a); };
template<> inline double abs(double a) {return fabs(a); };
template<> inline int abs(int a) {return ::abs(a); };

}; };
#endif
