/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_AUDIO_H
#define __MEDIA_AUDIO_H

#include "media.device.h"
#include "media.node.h"
#include "media.filter.h"

namespace magnum { namespace media {

class AudioDevice;
class AudioProducer;
class AudioConsumer;
class AudioFilter;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class AudioDevice : public Device {
DeclareClass(AudioDevice, Device);
public:
	AudioDevice();

	static AudioDevice*	create(const char* dev = Device::DefaultAudio, bool exclusive = false);

	inline AudioProducer*	createInput();
	inline AudioConsumer*	createOutput();
};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class AudioProducer : public Node {
DeclareClass(AudioProducer, Node);
public:
	inline AudioProducer(Device* dev, const char*name);

};


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class AudioConsumer : public Node {
DeclareClass(AudioConsumer, Node);
public:
	inline AudioConsumer(Device* dev, const char*name);

};


}; };

#endif
