/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_GRAPH_H
#define __MEDIA_GRAPH_H

#include "object.h"
#include "container.chain.h"
#include "media.node.h"

namespace magnum { namespace media {
using namespace magnum::container;
using magnum::object::Object;
using magnum::types::String;

class Buffer;
class Graph;
class Node;
class OutputPin;
class InputPin;


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Graph : public Object {
DeclareClass(Graph, Object);
private:
	Chain<Node>	m_Nodes;
	Node::State	m_State;

public:
	Graph();
	~Graph();

	bool		addNode(Node* node);
	bool		removeNode(Node* node);

	bool		connect(OutputPin* src, InputPin* dst);
	bool		disconnect(OutputPin* src, InputPin* dst);

	bool		start();
	bool		stop();
	bool		pause();
	bool		unpause();

	inline Node::State getState() const;
};

}; };

#endif
