/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_NODE_INL
#define __MEDIA_NODE_INL

namespace magnum { namespace media {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Node::addHandler(Handler* handler) {
	m_Handlers.insert(handler);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Node::removeHandler(Handler* handler) {
	m_Handlers.remove(handler);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Device* Node::getDevice() const {
	return m_Device;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph* Node::getGraph() const {
	return m_Graph;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node::State Node::getState() const {
	return m_State;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Node::getName() const {
	return m_Name;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	Node::lock() {
	return m_Mutex.lock();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Node::unlock() {
	return m_Mutex.unlock();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Node::isLocked() const {
	return m_Mutex.isLocked();
}


}; };

#endif
