/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __MEDIA_PIN_INL
#define __MEDIA_PIN_INL

namespace magnum { namespace media {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin::Pin(Node* node) {
	ASSERT(node != NULL);
	m_Node = node;
	m_Connection = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin::~Pin() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Pin* Pin::getConnection() const {
	return m_Connection;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Graph* Pin::getGraph() const {
	return m_Node->getGraph();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Node* Pin::getNode() const {
	return m_Node;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Pin::isConnected() const {
	return (m_Connection != NULL);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputPin::InputPin(Node* node) : Pin(node) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline InputPin* OutputPin::getConnection() const {
	return (InputPin *)Pin::getConnection();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputPin::OutputPin(Node* node) : Pin(node) {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline OutputPin* InputPin::getConnection() const {
	return (OutputPin *)Pin::getConnection();
}



}; };
#endif
