/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __NET_EXCEPTION_H
#define __NET_EXCEPTION_H

#include "io.exception.h"

namespace magnum { namespace net {
using magnum::object::Object;
using magnum::types::String;
using magnum::io::IOException;

DeclareException(NetworkException, IOException);

DeclareException(UnknownHostException,  NetworkException);
DeclareException(SocketException, NetworkException);
DeclareException(ProtocolException, NetworkException);
DeclareException(TimeOutException, NetworkException);

DeclareException(ConnectException, SocketException);
DeclareException(ConnectionRefusedException, ConnectException);
DeclareException(ConnectionResetException, SocketException);
DeclareException(ConnectionClosedException, SocketException);
DeclareException(BindException, SocketException);
DeclareException(NoRouteToHostException, SocketException);

}; };

#endif
