/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __OBJECT_CLASS_H
#define __OBJECT_CLASS_H

#include "object.h"
#include "base.string.h"

namespace magnum { namespace types {
class String;
}; };


namespace magnum { namespace object {
using magnum::object::Object;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Class : public Object {
DeclareClass(Class, Object);
friend class Object;
private:
	String				m_ClassName;
	
	inline Class(const Object& );

public:
	inline String		getName() const;
	inline String		toString() const;

	inline bool			isSubclass(const Class& ) const;
	inline bool			isSubclass(const Object& ) const;
	inline bool			isSubclass(const String& ) const;

	inline bool			isSuperclass(const Class& ) const;
	inline bool			isSuperclass(const Object& ) const;
	inline bool			isSuperclass(const String& ) const;

	inline bool			isInstance(const Object& ) const;

	inline Class		getSuperclass() const;

	inline bool operator==(const String& str) const;
	inline bool operator==(const Class& str) const;
	inline bool operator!=(const String& str) const;
	inline bool operator!=(const Class& str) const;

	static Class		forName(const String& );
};

}; };
#endif
