/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __OBJECT_CLASS_INL
#define __OBJECT_CLASS_INL

namespace magnum { namespace object {
using namespace magnum::types;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Class::Class(const Object& obj) {
	m_ClassName = obj.getClassName();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Class::getName() const {
	return m_ClassName;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Class::toString() const {
	return m_ClassName;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSubclass(const Class& c) const {
	return c.m_ClassName.startsWith(m_ClassName+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSubclass(const Object& c) const {
	return c.getClassName().startsWith(m_ClassName+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSubclass(const String& c) const {
	return c.startsWith(m_ClassName+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSuperclass(const Class& c) const {
	return m_ClassName.startsWith(c.m_ClassName+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSuperclass(const Object& c) const {
	return m_ClassName.startsWith(c.getClassName()+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isSuperclass(const String& c) const {
	return m_ClassName.startsWith(c+":");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::isInstance(const Object& c) const {
	return m_ClassName == c.getClassName();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::operator==(const String& str) const {
	return m_ClassName == str;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::operator==(const Class& str) const {
	return m_ClassName == str.m_ClassName;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::operator!=(const String& str) const {
	return m_ClassName != str;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool Class::operator!=(const Class& str) const {
	return m_ClassName != str.m_ClassName;
}

}; };
#endif
