/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __OBJECT_OBJECT_INL
#define __OBJECT_OBJECT_INL

namespace magnum { namespace object {
using namespace magnum::types;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Object::Object() {
	m_Reference = 1;
	m_WaitingThreads = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Object::Object(const Object& ) {
	m_Reference = 1;
	m_WaitingThreads = NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Class Object::getClass() const {
	return Class(*this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Object::getClassNameRec() const {
	return String("Object");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline String Object::getClassName() const {
	return String("Object");
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void Object::refer() {
	m_Reference++;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	Object::release() {
	if (m_Reference == 1)
		delete this;
	else
 		m_Reference--;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline int Object::getReference() const {
	return m_Reference;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Object& Object::operator=(const Object& ) {
	return *this;
}

}; };
#endif
