/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_AUDIOQUEUE_INL
#define __SCENE3D_AUDIOQUEUE_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void AudioQueue::insert(SoundNode* node) {
	node->setFlag(Node::ActiveSound);
	if (node->getChain() != NULL)
		return;
	m_ActiveSounds.insert(node);
	node->onStart();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void	AudioQueue::remove(SoundNode* node) {
	node->clearFlag(Node::ActiveSound);
	m_ActiveSounds.remove(node);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline bool	AudioQueue::contains(const SoundNode* m) const {
	return m_ActiveSounds.contains(m);
}

}; };

#endif
