/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_GEOMETRY_H
#define __SCENE3D_GEOMETRY_H

#include "container.chain.h"
#include "scene3d.graphics.h"

namespace magnum { namespace scene3d {
using magnum::container::Chainable;

class RenderQueue;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Geometry : public Graphics, private Chainable<Geometry> {
DeclareClass(Geometry, Graphics);
friend class RenderQueue;
private:
	Transform3<float>		m_Transform;
	Transform3<float>		m_WorldTransform;

public:
	inline Geometry();
	
	inline void				setTransform(const Transform3<float>& );
	inline const Transform3<float>& getTransform() const;

	inline void				setWorldTransform(const Transform3<float>& );
	inline const Transform3<float>& getWorldTransform() const;

protected:
	virtual void			onAttachLocale(Locale* );
	virtual void			onDetachLocale(Locale* );
	virtual void			onEnable();
	virtual void			onDisable();
	virtual void			onRender() const;
	virtual void			onTransform(const Transform3<float>& parent);
	virtual void			onSchedule(RenderQueue* ,const Transform3<float>& );
};	

}; }; 

#endif
