/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_GRAPHICS_H
#define __SCENE3D_GRAPHICS_H

#include "scene3d.leaf.h"
#include "scene3d.observer.h"

namespace magnum { namespace scene3d {

class RenderQueue;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Graphics : public Leaf<Graphics> {
DeclareClass(Graphics, Leaf<Graphics>);
friend class Observer::GraphicsTraverser;
friend class RenderQueue;
public:
	enum Type {
		GeometryType	= 0x00000200,
		ModifierType	= 0x00000400,
		LightType		= 0x00000800,
		BackgroundType	= 0x00001000,
		AllGraphics		= 0x0000ff00,
	};

protected:
	inline explicit Graphics(Type t);

public:
	inline Graphics();

protected:
	virtual void		onSchedule(RenderQueue* ,const Transform3<float>& );
};

}; };

#endif
