/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_LISTENERNODE_H
#define __SCENE3D_LISTENERNODE_H

#include "scene3d.audio.h"
#include "audio3d.listener.h"
#include "geometry.frustum.h"

namespace magnum { namespace scene3d {
using magnum::audio3d::Listener;
using magnum::geometry::Frustum3;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ListenerNode : public Audio {
DeclareClass(ListenerNode, Audio);
private:
	Listener			m_Listener;
	Vector3<float>		m_Position;
	Vector3<float>		m_Velocity;
	Transform3<float>	m_WorldTransform;
	Vector3<float>		m_WorldPosition;

public:
	inline ListenerNode();

	inline Vector3<float>	getPosition() const;
	inline void				setPosition(const Vector3<float>& );

	inline Vector3<float>	getVelocity() const;
	inline void				setVelocity(const Vector3<float>& );

	inline const Transform3<float>& getWorldTransform() const;
	inline const Vector3<float>& getWorldPosition() const;

protected:
	virtual void		onAttachLocale(Locale* );
	virtual void		onDetachLocale(Locale* );
	virtual void		onEnable();
	virtual void		onDisable();
	virtual void		onTransform(const Transform3<float>& );
};

}; };

#endif
