/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_MODELNODE_H
#define __SCENE3D_MODELNODE_H

#include "object.pointer.h"
#include "geometry.transform.h"
#include "scene3d.geometry.h"
#include "graphics3d.model.h"

namespace magnum { namespace scene3d {
using magnum::object::Pointer;
using magnum::math::Matrix4;
using magnum::geometry::Transform3;
using magnum::graphics3d::Model;
using magnum::graphics3d::ParameterBuffer;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class ModelNode : public Geometry {
DeclareClass(ModelNode, Geometry);
private:
	Pointer<Model>			m_Model;
	ParameterBuffer*		m_Parameters;
	Matrix4<float>*			m_ModelMatrix;

public:
	inline ModelNode();
	inline explicit ModelNode(Model* );
	inline ~ModelNode();

	void					attachModel(Model* );
	void					detachModel();
	inline Model*			getModel() const;

protected:
	virtual void			onSchedule(RenderQueue* ,const Transform3<float>& );
	virtual void			onRender() const;
};


}; };

#endif
