/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_SCHEDULER_H
#define __SCENE3D_SCHEDULER_H

#include "container.scheduler.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::container::Scheduler;

class Behaviour;
class Observer;
class Universe;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class BehaviourScheduler : public Object {
DeclareClass(BehaviourScheduler, Object);
private:
	Observer*			m_Observer;
	Universe*			m_Universe;
	Scheduler<Behaviour> m_ActiveBehaviours;

public:
	BehaviourScheduler(Observer* );
	~BehaviourScheduler();

	inline void			insert(Behaviour* );
	inline void			remove(Behaviour* );
	inline bool			contains(const Behaviour* ) const;

	void				clear();
	
	void				process();
};


}; };

#endif
