/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_TIMER_H
#define __SCENE3D_TIMER_H

#include "system.timestamp.h"

namespace magnum { namespace scene3d {
using magnum::object::Object;
using magnum::types::String;
using magnum::system::Timestamp;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Timer : public Object {
DeclareClass(Timer, Object);
private:
	Timestamp		m_Timestamp;
	double			m_Difference;
	double			m_Current;
	double			m_Previous;
	double			m_Elapsed;
	
public:
	inline explicit Timer(double = 0.0);

	void			init(double );
	void			update();
	
	inline double	getCurrent() const;
	inline double	getPrevious() const;
	inline double	getElapsed() const;
};

}; };

#endif
