/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SCENE3D_TRANSFORMGROUP_INL
#define __SCENE3D_TRANSFORMGROUP_INL

namespace magnum { namespace scene3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline TransformGroup::TransformGroup() : Group(Node::TransformType) {
	m_Transform.identity();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline TransformGroup::TransformGroup(const Transform3<float>& t) : Group(Node::TransformType) {
	m_Transform = t;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline void TransformGroup::setTransform(const Transform3<float>& mtx) {
	m_Transform = mtx;
	if (hasParentTransform())
		applyParentTransform();
	else
		setWorldTransform(mtx);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline const Transform3<float>& TransformGroup::getTransform() const {
	return m_Transform;
}

}; };

#endif
