/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __STATS_PERMUTATION_INL
#define __STATS_PERMUTATION_INL

namespace magnum { namespace stats {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Permutation::Permutation(unsigned int size) {
	m_Size = 0;
	m_Permutation = 0;
	setSize(size);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline Permutation::~Permutation() {
	if (m_Permutation != NULL)
		delete[] m_Permutation;
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int Permutation::getSize() const {
	return m_Size;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
inline unsigned int	Permutation::operator[](unsigned int i) const {
	ASSERT(i < m_Size);
	return m_Permutation[i];
}

}; };

#endif
