/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#ifndef __SYSTEM_SIGNAL_H
#define __SYSTEM_SIGNAL_H

#include "object.h"

# if defined(__FORUNIX__)
#	include <pthread.h>
# endif


namespace magnum { namespace system {
using magnum::object::Object;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
class Signal : public Object {
DeclareClass(Signal, Object);
private:
	bool			m_Signaled;

#if defined(__FORWINDOWS__)
	HANDLE			m_Event;
#else
	pthread_cond_t	m_Event;
	pthread_mutex_t m_Mutex;
#endif

public:
	inline	Signal();
	inline	~Signal();

	inline	bool 	raise(bool autoreset=false);
	inline	bool 	reset();
	inline	bool 	wait();
	inline	bool 	isRaised() const;
};

}; };

#endif
