/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "freetype.descriptor.h"
#include "freetype.font.h"

#include "freetype.descriptor.inl"
#include "graphics.dimension.inl"
#include "base.string.inl"


namespace magnum { namespace freetype {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Descriptor::Descriptor() {
	m_Size.setWidth(16.0f);
	m_Size.setHeight(16.0f);
	m_Style = Font::Regular;
	m_Encoding = Encoding::None;
	m_Kerning = false;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Descriptor::operator==(const Descriptor& d) const {
	if (d.m_Encoding != m_Encoding)
		return false;
	if (d.m_Kerning != m_Kerning)
		return false;
	if (d.m_Size != m_Size)
		return false;
	if (d.m_Style != m_Style)
		return false;
	if (d.m_Family != m_Family)
		return false;
	return true;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Descriptor::operator!=(const Descriptor& d) const {
	if (d.m_Encoding != m_Encoding)
		return true;
	if (d.m_Kerning != m_Kerning)
		return true;
	if (d.m_Size != m_Size)
		return true;
	if (d.m_Style != m_Style)
		return true;
	if (d.m_Family != m_Family)
		return true;
	return false;
}


}; };
