/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "io.exception.h"
#include "graphics.translator.tiff.h"

#include "object.inl"
#include "object.exception.inl"
#include "base.string.inl"
#include "io.translator.inl"
#include "container.chain.inl"
#include "graphics.translator.inl"
#include "graphics.palette.inl"
#include "graphics.colour.inl"
#include "graphics.image.inl"
#include "graphics.dimension.inl"

#include <setjmp.h>


namespace magnum { namespace graphics {



/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
TranslatorTIFF::TranslatorTIFF() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
TranslatorTIFF::~TranslatorTIFF() {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Image* TranslatorTIFF::onDecode(InputStream* in, long size) {
	return NULL;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
long TranslatorTIFF::onEncode(OutputStream* out, const Image* img) {
	return 0;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool TranslatorTIFF::onIdentify(File* in) {
	dword id;

	try {
		unsigned long oldpos;
		oldpos = in->getPosition();	
		in->read(&id, sizeof(id));
		in->setPosition(oldpos, File::Absolute);
	} catch (...) {
		return false;
	}

	if (id == (((unsigned long)42 << 24) + 0x4d4d))
		return true;
	if (id == (((unsigned long)42 << 16) + 0x4949))
		return true;

	return false;
} 


}; };
