/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "graphics3d.context.h"
#include "graphics3d.material.h"
#include "graphics3d.vertexformat.h"

#include "object.inl"
#include "base.string.inl"
#include "system.thread.inl"
#include "system.assembler.inl"
#include "graphics3d.context.inl"
#include "graphics3d.material.inl"
#include "graphics3d.resource.inl"
#include "graphics3d.vertexformat.inl"


namespace magnum { namespace graphics3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Material::~Material() {
	// Remove Material from all Contexts!
	Context* context = getContext();
	if (context != NULL) {
		MaterialStack* ms = context->getMaterialStack();
		if (ms->m_Material == this)
			ms->m_Material = NULL;
	}
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Material::compileSelect(Assembler& as) const {
	Context* c = getContext();
	int offset = (int)((byte*)&c->getMaterialStack()->m_Material - (byte*)c);
	as.asmLoad(Assembler::T0, (int)(intptr_t)this);
	as.asmStore(Assembler::R0, offset, Assembler::T0);
	if (onCompileSelect(as) == false)
		as.asmCall((void (Material::*)() const)Material::onSelect, this);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void Material::onSelect() const {
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool Material::onCompileSelect(Assembler& ) const {
	return false;
}


}; };
