/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "math.vector4.h"
#include "graphics3d.context.h"
#include "graphics3d.pointlight.h"
#include "graphics3d.vertexformat.h"

#include "system.thread.inl"
#include "math.vector3.inl"
#include "math.vector4.inl"
#include "graphics.colour.inl"
#include "graphics3d.context.inl"
#include "graphics3d.pointlight.inl"
#include "graphics3d.light.inl"
#include "graphics3d.resource.inl"
#include "graphics3d.vertexformat.inl"


namespace magnum { namespace graphics3d {
using magnum::math::Vector4;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
void PointLight::onSelect(unsigned int light) const {
	ASSERT(light < Light::MaxLights);
	Vector4<float> pos = m_Position;
	pos.w = 1.0f;
	glLightfv(GL_LIGHT0 + light, GL_AMBIENT, (const float *)m_Ambient);
	glLightfv(GL_LIGHT0 + light, GL_DIFFUSE, (const float *)m_Diffuse);
	glLightfv(GL_LIGHT0 + light, GL_SPECULAR, (const float *)m_Specular);
	glLightfv(GL_LIGHT0 + light, GL_POSITION, (const float *)pos);
	glLightf(GL_LIGHT0 + light, GL_CONSTANT_ATTENUATION, m_Attenuation.x);
	glLightf(GL_LIGHT0 + light, GL_LINEAR_ATTENUATION, m_Attenuation.y);
	glLightf(GL_LIGHT0 + light, GL_QUADRATIC_ATTENUATION, m_Attenuation.z);
	glLightf(GL_LIGHT0 + light, GL_SPOT_CUTOFF, 180.0f);
	glLightf(GL_LIGHT0 + light, GL_SPOT_EXPONENT, 0.0f);
}

}; };
