/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "gui3d.stringview.h"
#include "gui3d.context.h"
#include "gui3d.fontmap.h"
#include "gui3d.root.h"

#include "object.pointer.inl"
#include "gui3d.context.inl"
#include "gui3d.fontmap.inl"
#include "gui3d.view.inl"

namespace magnum { namespace gui3d {

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
StringView::StringView(const Rectangle<float>& r) : View(r) {
	m_Font = NULL;
	m_Colour = Colour<float>(1.0f, 1.0f, 1.0f);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
StringView::StringView(const Rectangle<float>& r,const char* str) : View(r) {
	m_Font = NULL;
	m_Colour = Colour<float>(1.0f, 1.0f, 1.0f);
	m_Text = str;
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool StringView::onPaint() {
	if (m_Font == NULL)
		return true;
	if (m_FontMap == NULL)
		m_FontMap = getContext()->createFont(m_Font);
		
	getContext()->setColour(m_Colour);
	getContext()->selectFont(m_FontMap);
	getContext()->drawString(Point<float>(0,0), m_Text);
	
	return true;
}

}; };

