/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "media.device.h"
#include "media.node.h"
#include "media.audio.h"
#include "media.audiorenderer.h"

#include "base.string.inl"
#include "object.class.inl"
#include "object.inl"
#include "container.list.inl"
#include "system.thread.inl"
#include "media.node.inl"
#include "media.audio.inl"
#include "media.audiorenderer.inl"


# if defined(__FORWINDOWS__)
#	include "media.wavedevice.win.h"
#	include "media.waveproducer.win.h"
#	include "media.waveconsumer.win.h"
#endif



namespace magnum { namespace media { 

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
AudioDevice::AudioDevice() {
	publishNode(AudioRenderer::NodeName, AudioRenderer::NodeType, AudioRenderer::NodeCreator);
}

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
AudioDevice* AudioDevice::create(const char* which, bool exclusive) {
	String name(which);

#if defined(__FORWINDOWS__)
	if (name == Device::DefaultAudio)
		return new magnum::media::_windows::WaveDevice();
#endif

	return NULL;
}

}; };

