/* 
  Magnum 
  Copyright (C) 2002-2004 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "media.wavedevice.win.h"
#include "media.waveproducer.win.h"
#include "media.waveconsumer.win.h"

#include "base.string.inl"
#include "object.class.inl"
#include "object.inl"
#include "system.thread.inl"
#include "system.signal.inl"
#include "container.list.inl"
#include "media.node.inl"
#include "media.audio.inl"

#include "media.wavedevice.win.inl"
#include "media.waveproducer.win.inl"
#include "media.waveconsumer.win.inl"

#ifndef __FORWINDOWS__
#	error "This file is only for Windows!"
#endif


namespace magnum { namespace media { namespace _windows {


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
WaveDevice::WaveDevice() {
	publishNode(Node::DefaultInput, Node::Input, createInput);
	publishNode("WaveProducer", Node::Input, createInput);
	publishNode(Node::DefaultOutput, Node::Output, createOutput);
	publishNode("WaveConsumer", Node::Output, createOutput);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
WaveDevice::~WaveDevice() {

}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Node* WaveDevice::createInput(Device* dev, const char* name) {
	return new WaveProducer((WaveDevice *)dev);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
Node* WaveDevice::createOutput(Device* dev, const char* name) {
	return new WaveConsumer((WaveDevice *)dev);
}

}; }; };

